program categ_obs

   ! Compilacao:
   ! sudo -u climaoper gfortran categoriza_obs.f90 -o categoriza_obs.x

   implicit none
   
   integer, parameter         :: X=176, Y=160
   integer                    :: i, ix, iy, a, b, j
   real                       :: temporario
   real, dimension(90, X, Y)  :: prec
   real, dimension(30, X, Y)  :: prec30, prec30ord
   real, dimension(X, Y)      :: li, ls
   character(len=11)          :: arqin
   character(len=3)           :: tri
   
   ! Input files:
   open(10, file='../scripts/obs_namelist.txt')
   open(11, file='../scripts/categoriza_obs.nml')
   read(11, *)tri
   
   ! Outut files:
   open(20, file='../../../datain/observacao_row/categorizacao_climatologica/categ_obs_'//tri//'81-10.bin', &
   status='unknown',access='direct',recl=X*Y*4)
   
   
   ! Input data, prec mensal, M1, M2, M3 de 1981 a 2010: 90 meses
   do i=1, 90
      read(10, *) arqin
!      print*, arqin
      open(12, file='/oper/clima/public/DADOS/BRASIL/precipitacao/mensal/binario/historicos/'//arqin, &
      status='old',access='direct',recl=X*Y*4)
      read(12, rec=1) prec(i, :, :)
      close(12)
   enddo
   
   j=1
   do i=1, 90, 3
      prec30(j, :, :)=(prec(i, :, :)+prec(i+1, :, :)+prec(i+2, :, :))/3.0
      j=j+1
   enddo
   
   
   prec30ord=prec30
   

   
   do ix=1, X
      do iy=1, Y

         if (prec30ord(1, ix, iy) >= 777.0 .and. prec30ord(1, ix, iy) <= 778.0) then
            li(ix, iy)=-9.99e+08
            ls(ix, iy)=-9.99e+08
         else

            ! bubble sort -------------------------------
            do a=1,30
               do b=a,30
                  if(prec30ord(a, ix, iy) >= prec30ord(b, ix, iy))then
                     temporario=prec30ord(a, ix, iy)
                     prec30ord(a, ix, iy)=prec30ord(b, ix, iy)
                     prec30ord(b, ix, iy)=temporario
                  endif
               enddo
            enddo
            !--------------------------------------------
         
            ! Define os limites inferiores e superiores:         
            li(ix, iy)=prec30ord(10, ix, iy)
            ls(ix, iy)=prec30ord(20, ix, iy)
       
         endif
       
      enddo
   enddo
   
   
   
!   do i=1, 30
!      print*, prec30(i, 85, 77), prec30ord(i, 85, 77), li(85, 77), ls(85, 77)
!   enddo
   
   
   write(20, rec=1) li
   write(20, rec=2) ls
   
   close(10)
   close(11)
   close(20)
   
end
